;---------------------------------------------------------------
; Codec Windows-1251
;  Windows-1251
;---------------------------------------------------------------

comment * ======================================================

              DLL   
                             MASM32

  . ():
ml /c /coff "console.asm"
PoLink /SUBSYSTEM:CONSOLE "console.obj"

: dyn-dll-use v.1.00 beta2
:  ..
 2020

 . Freeware, OpenSource. " ".
sadovoya@mtu-net.ru
sadovoya.narod.ru


================================================================ *



;        dll.  
;   - Windows API GetDefaultPrinterA()  . 
; Winspool.drv (  ,    dll).
;
;    BOOL GetDefaultPrinter(
;        LPTSTR  pszBuffer,
;	 LPDWORD pcchBuffer
;    );
;   -   -. 
;  -: .docs.microsoft.com
;
;-  1)    2)   



.486
.model flat, stdcall ;    - stdcall
option casemap :none   



include \masm32\include\windows.inc   ;    .
include \masm32\include\kernel32.inc  ;   Dll  .
include \masm32\include\user32.inc    ; CharToOem()

include \masm32\macros\macros.asm     ; SPROTO, halloc, hfree

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib



;     SPROTO  
;   stdcall;
; pF    - GetDefaultPrinterA
GetDefaultPrinterA SPROTO(pF,:DWORD,:DWORD)

my_print PROTO :DWORD, :DWORD
; -    ;
; -: 
; -    ,
; -  ;
; .      
;   hCons_Out

my_exit PROTO :DWORD, :DWORD
;      
;    ;
; -:
; -      
; -   ;
; my_print



.const
    ;c-like 
    dllName    db 'Winspool.drv',0 
    funName    db 'GetDefaultPrinterA',0 
    
    ; (    )
    errLoadLib   db ' LoadLibraryA',13,10
    errGetAddr   db ' GetProcAddress',13,10  
    errMem       db '  ',13,10 
    err_my_print db 'Error mem. alloc. in my_print',13,10 
                    ;     
    mesAgain     db 13,10,': '
    mesExit      db 13,10,' ',13,10

    
.data?
    hCons_Out HANDLE  ? ;     
    hLibrary  HMODULE ? ;  
    addrFun   FARPROC ? ;  - GetDefaultPrinterA
                        ; (     )
    
    ;        
    ;(     )
    aBuf DWORD ?
    Len  DWORD ?



.code

start:

    ;  
    mov hCons_Out, INVALID_HANDLE_VALUE
    mov hLibrary, NULL
    mov addrFun, NULL
    mov aBuf, NULL
    mov Len, NULL
 
    ;   
    invoke GetStdHandle, -11
    mov hCons_Out, eax
    .if hCons_Out == INVALID_HANDLE_VALUE
	invoke ExitProcess, 1000
    .endif 
    ;      
    
    ; 
    invoke LoadLibraryA, offset dllName
    mov hLibrary, eax
    .if hLibrary == NULL
        invoke my_exit, offset errLoadLib, sizeof errLoadLib    
    .endif
    
    ;  
    invoke GetProcAddress, hLibrary, offset funName
    mov addrFun, eax
    .if addrFun == NULL
         invoke my_exit, offset errGetAddr, sizeof errGetAddr    
    .endif
    
    ; ,  
    ;(  stdcall)
    push offset Len
    push NULL
    call [addrFun] 
    ;   c NULL    
    
    ;    
    ;(     )
    mov aBuf, halloc(Len)
    .if aBuf == NULL
        invoke my_exit, offset errMem, sizeof errMem
    .endif

    push offset Len
    push aBuf
    call [addrFun] ;      
    
    ;   
    invoke my_print, aBuf, Len

    invoke my_print, offset mesAgain, sizeof mesAgain

    ;  --    
    mov eax, addrFun
    mov pF, eax ;   
    invoke GetDefaultPrinterA, aBuf, offset Len

    ; ,   
    invoke FreeLibrary, hLibrary

    invoke my_print, aBuf, Len

    hfree aBuf ;  

    invoke my_print, offset mesExit, sizeof mesExit
    
    invoke Sleep, 3000
    invoke ExitProcess, 0



my_print proc a_buf:DWORD, sz:DWORD
    LOCAL hHeap : DWORD
    mov hHeap, NULL
    mov hHeap, halloc(sz) ;    
    .if hHeap == NULL
        invoke WriteConsoleA, hCons_Out, offset err_my_print, \
            sizeof err_my_print, NULL, NULL
        ret
    .endif
    invoke CharToOemA, a_buf, hHeap
    invoke WriteConsoleA, hCons_Out, hHeap, sz, NULL, NULL
    hfree hHeap ;  
    ret
my_print endp



my_exit proc aMes:DWORD, szMes:DWORD
    .if hLibrary != NULL
        invoke FreeLibrary, hLibrary
    .endif
    .if aBuf != NULL
        hfree aBuf
    .endif
    invoke my_print, aMes, szMes 
    invoke Sleep, 3000
    invoke ExitProcess, 2000
my_exit endp



end start
